'======================================================
' FUNGUS_B.BI - QB Include File for Global Functions
' FUNGUS Ver. 1.02.04
' for use with FUNGUS.BAS or the FUNGUS.QLB
'
' If Your Silly & Know It, Clap Your Hands...
'======================================================
    CONST FALSE = 0, TRUE = NOT FALSE

'---------------------------------------------
' Date/Time Functions
'---------------------------------------------
DECLARE FUNCTION IsLeapYear% (YearNum AS INTEGER)
DECLARE FUNCTION DateToJulian& (BYVAL nMonth AS INTEGER, BYVAL nDay AS INTEGER, BYVAL nYear AS INTEGER)
DECLARE FUNCTION JulianToDate% (BYVAL lnJulian AS LONG, nMonth AS INTEGER, nDay AS INTEGER, nYear AS INTEGER)
DECLARE FUNCTION JulianToSerial# (BYVAL lnJulian AS LONG)
DECLARE FUNCTION SerialToJulian& (BYVAL dSerial AS DOUBLE)
DECLARE FUNCTION DaysBtwnDates& (BYVAL m1 AS INTEGER, BYVAL d1 AS INTEGER, BYVAL y1 AS INTEGER, BYVAL m2 AS INTEGER, BYVAL d2 AS INTEGER, BYVAL y2 AS INTEGER)
DECLARE FUNCTION DaysInMonth% (BYVAL nMonth AS INTEGER, BYVAL nYear AS INTEGER)
DECLARE FUNCTION CalcMoon% (BYVAL nMonth AS INTEGER, BYVAL nDay AS INTEGER, BYVAL nYear AS INTEGER)
DECLARE FUNCTION IsHoliday% (sHoliday1 AS STRING, sHoliday2 AS STRING, BYVAL nMonth AS INTEGER, BYVAL nDay AS INTEGER, BYVAL nYear AS INTEGER)
DECLARE FUNCTION IsValidDate% (BYVAL nMonth AS INTEGER, BYVAL nDay AS INTEGER, BYVAL nYear AS INTEGER)
DECLARE FUNCTION DayOfWeek% (BYVAL nMonth AS INTEGER, BYVAL nDay AS INTEGER, BYVAL nYear AS INTEGER)
DECLARE FUNCTION CalcSunRise# (BYVAL Latdec AS SINGLE, BYVAL Longdec AS SINGLE, BYVAL nMonth AS INTEGER, BYVAL nDay AS INTEGER, BYVAL nYear AS INTEGER)
DECLARE FUNCTION CalcSunSet# (BYVAL Latdec AS SINGLE, BYVAL Longdec AS SINGLE, BYVAL nMonth AS INTEGER, BYVAL nDay AS INTEGER, BYVAL nYear AS INTEGER)
DECLARE FUNCTION IsDstNow% (BYVAL nMonth AS INTEGER, BYVAL nDay AS INTEGER, BYVAL nYear AS INTEGER)

'---------------------------------------------
' String Functions
'---------------------------------------------
DECLARE FUNCTION StrTok$ (Srce$, Delim$)
DECLARE FUNCTION SQLFmtStr$ (s AS STRING)
DECLARE FUNCTION RanString$ (nDigits AS INTEGER)
DECLARE FUNCTION XorCrypt$ (enctext AS STRING, enckey AS STRING)
DECLARE FUNCTION XorGenKey$ (genlength AS INTEGER)
DECLARE FUNCTION Center$ (text$, NumCol%)
DECLARE FUNCTION StripCRLF$ (sChars AS STRING)
DECLARE FUNCTION StripTab$ (sChars AS STRING)
DECLARE FUNCTION StripCurrency$ (sChars AS STRING)
DECLARE FUNCTION StripNull$ (sChars AS STRING)

'---------------------------------------------
' Conversion Functions
'---------------------------------------------
DECLARE FUNCTION CalcFactor! (margin AS SINGLE)
DECLARE FUNCTION CalcMargin! (factor AS SINGLE)
DECLARE FUNCTION CalcDegToDec! (BYVAL nDegree AS INTEGER, BYVAL nMinutes AS INTEGER, BYVAL nSeconds AS INTEGER)
DECLARE FUNCTION CalcDecToHM% (BYVAL dTime AS DOUBLE, nHour AS INTEGER, nMinute AS INTEGER)
DECLARE FUNCTION CalcDMSToRad! (BYVAL nDegree AS INTEGER, BYVAL nMinute AS INTEGER, BYVAL nSecond AS INTEGER)
DECLARE FUNCTION CalcRadToDec! (snRadians AS SINGLE)
DECLARE FUNCTION MilesToFeet! (miles AS SINGLE)
DECLARE FUNCTION FeetToMiles! (feet AS SINGLE)
DECLARE FUNCTION InchesToFeet! (inches AS SINGLE)
DECLARE FUNCTION FeetToInches! (feet AS SINGLE)
DECLARE FUNCTION InchesToMeters! (inches AS SINGLE)
DECLARE FUNCTION MetersToInches! (meters AS SINGLE)
DECLARE FUNCTION MilesToKm! (miles AS SINGLE)
DECLARE FUNCTION KmToMiles! (km AS SINGLE)
DECLARE FUNCTION SqFtToSqIn! (sf AS SINGLE)
DECLARE FUNCTION SqInToSqFt! (si AS SINGLE)
DECLARE FUNCTION CalcAcre! (sf AS SINGLE)
DECLARE FUNCTION SqInToSqCm! (si AS SINGLE)
DECLARE FUNCTION CalcSqMile! (acre AS SINGLE)
DECLARE FUNCTION CiToCc! (ci AS SINGLE)
DECLARE FUNCTION CcToCi! (cc AS SINGLE)
DECLARE FUNCTION TbsToTsp! (tbs AS SINGLE)
DECLARE FUNCTION TbsToOz! (tbs AS SINGLE)
DECLARE FUNCTION CupToOz! (cup AS SINGLE)
DECLARE FUNCTION PtToOz! (pt AS SINGLE)
DECLARE FUNCTION QtToOz! (qt AS SINGLE)
DECLARE FUNCTION OzToTbs! (oz AS SINGLE)
DECLARE FUNCTION LiterToQt! (lt AS SINGLE)
DECLARE FUNCTION QtToLiter! (qt AS SINGLE)
DECLARE FUNCTION OzToGm! (oz AS SINGLE)
DECLARE FUNCTION LbsToKgm! (lbs AS SINGLE)
DECLARE FUNCTION CelToFahr! (cel AS SINGLE)
DECLARE FUNCTION FahrToCel! (fahr AS SINGLE)
DECLARE FUNCTION CelToKel! (cel AS SINGLE)
DECLARE FUNCTION SimpInt! (BYVAL snPrin AS SINGLE, BYVAL snRate AS SINGLE, BYVAL snTime AS SINGLE)
DECLARE FUNCTION CompInt! (BYVAL snPrin AS SINGLE, BYVAL snRate AS SINGLE, BYVAL nComp AS INTEGER, BYVAL nPeriod AS INTEGER)
DECLARE FUNCTION TimeToDouble% (BYVAL snRate AS SINGLE, BYVAL nComp AS SINGLE)

'---------------------------------------------
' Arithmetic Functions
'---------------------------------------------
DECLARE FUNCTION LogTen! (X!)
DECLARE FUNCTION Sec! (snx AS SINGLE)
DECLARE FUNCTION CSC! (snx AS SINGLE)
DECLARE FUNCTION COT! (snx AS SINGLE)
DECLARE FUNCTION ARCSIN! (snx AS SINGLE)
DECLARE FUNCTION ARCCSC! (snx AS SINGLE)

