'==============================================
' FUNG_B2.BAS - Demo and Test FUNGUS_B.QLB
' By Mike DeBacker
'==============================================

'$INCLUDE: 'FUNGUS_B.BI'
    DECLARE SUB StringMenu ()
    DECLARE SUB DemoStrTok ()
    DECLARE SUB MainMenu ()
    DECLARE SUB DateMenu ()
    DECLARE SUB DemoIsLeapYear ()
    DECLARE SUB ConvertMenu ()
    DECLARE SUB DemoCalcMargin ()
    DECLARE SUB DemoCalcFactor ()
    DECLARE SUB DemoJulianToDate ()
    DECLARE SUB DemoDateToJulian ()
    DECLARE SUB DemoCalcMoon ()
    DECLARE SUB DemoDayOfWeek ()
    DECLARE SUB DemoIsHoliday ()
    DECLARE SUB DemoCalcSunRise ()
    DECLARE SUB DemoMiles ()
    DECLARE SUB DemoCompInt ()
    

    CALL MainMenu

END

SUB ConvertMenu
    DO WHILE -1
        CLS
        PRINT "==========================================="
        PRINT "        GLOBAL FUNCTIONS TEST PROGRAM"
        PRINT "===========Conversion Functions============"
        PRINT "1] Calc Margin"
        PRINT "2] Calc Factor"
        PRINT "3] Calc Miles"
        PRINT "4] Calc Compound Interest & Time To Double"
        PRINT "M] Return To Main"
        PRINT ""
        PRINT "Please Select"
        A$ = ""
        DO
            A$ = INKEY$
        LOOP WHILE A$ = ""
        A$ = UCASE$(A$)
        SELECT CASE A$
            CASE "1": CALL DemoCalcMargin
            CASE "2": CALL DemoCalcFactor
            CASE "3": CALL DemoMiles
            CASE "4": CALL DemoCompInt
            CASE "M": EXIT SUB
            CASE ELSE: BEEP
        END SELECT
    LOOP

END SUB

SUB DateMenu
    DO WHILE -1
        CLS
        PRINT "==========================================="
        PRINT "        GLOBAL FUNCTIONS TEST PROGRAM"
        PRINT "===========Date/Time Functions============="
        PRINT "1] Is Leap Year?"
        PRINT "2] Date to Julian"
        PRINT "3] Julian to Date"
        PRINT "4] Lunar Phase"
        PRINT "5] Day of Week"
        PRINT "6] Is Today A Holiday"
        PRINT "7] Time of Sun Rise"
        PRINT "M] Return To Main"
        PRINT ""
        PRINT "Please Select"
        A$ = ""
        DO
            A$ = INKEY$
        LOOP WHILE A$ = ""
        A$ = UCASE$(A$)
        SELECT CASE A$
            CASE "1": CALL DemoIsLeapYear
            CASE "2": CALL DemoDateToJulian
            CASE "3": CALL DemoJulianToDate
            CASE "4": CALL DemoCalcMoon
            CASE "5": CALL DemoDayOfWeek
            CASE "6": CALL DemoIsHoliday
            CASE "7": CALL DemoCalcSunRise
            CASE "M": EXIT SUB
            CASE ELSE: BEEP
        END SELECT
    LOOP
END SUB

SUB DemoCalcFactor
    PRINT : PRINT
    PRINT "CalcFactor"
    INPUT "Please Enter Profit Margin (xx): "; X!
    y! = CalcFactor(X!)
    PRINT "The answer is :"; STR$(y!)

    PRINT "Press Any Key To Continue..."
    DO
    LOOP WHILE INKEY$ = ""

END SUB

SUB DemoCalcMargin
    PRINT : PRINT
    PRINT "CalcMargin"
    INPUT "Please Enter Margin Factor (xx.xx): "; X!
    y! = CalcMargin(X!)
    PRINT "The answer is :"; STR$(y!)

    PRINT "Press Any Key To Continue..."
    DO
    LOOP WHILE INKEY$ = ""
END SUB

SUB DemoCalcMoon
    PRINT : PRINT
    PRINT "CalcMoon"
    INPUT "Please Enter Month (mm): "; mn%
    INPUT "Please Enter Day (dd): "; dy%
    INPUT "Please Enter Year (yyyy): "; yr%
    X% = CalcMoon(mn%, dy%, yr%)
    PRINT "The answer is :"; X%

    PRINT "Press Any Key To Continue..."
    DO
    LOOP WHILE INKEY$ = ""
END SUB

SUB DemoCalcSunRise
    PRINT : PRINT
    PRINT "CalcSunrise and SunSet For Los Angeles"
    INPUT "Please Enter Month (mm): "; mn%
    INPUT "Please Enter Day (dd): "; dy%
    INPUT "Please Enter Year (yyyy): "; yr%
    'INPUT "Please Enter Latitude (ddd, mm): "; latdeg%, latmin%
    'INPUT "Please Enter Longitude (ddd, mm): "; longdeg%, longmin%

    latdeg% = 34: latmin% = 4
    longdeg% = 118: longmin% = 15

IF IsValidDate(mn%, dy%, yr%) THEN
    Latdec! = CalcDegToDec(latdeg%, latmin%, 0)
    Longdec! = CalcDegToDec(longdeg%, longmin%, 0)
    t# = CalcSunRise(Latdec!, Longdec!, mn%, dy%, yr%)
    IF IsDstNow(mn%, dy%, yr%) THEN
        t# = t# + 1
        sT$ = "DST"
    ELSE
        sT$ = "STD"
    END IF
    X% = CalcDecToHM%(t#, hh%, mm%)
  
    PRINT "Sunrise :"; t#; " or "; hh%; ":"; mm%; sT$

    t# = CalcSunSet(Latdec!, Longdec!, mn%, dy%, yr%)
    IF IsDstNow(mn%, dy%, yr%) THEN
        t# = t# + 1
        sT$ = "DST"
    ELSE
        sT$ = "STD"
    END IF
    X% = CalcDecToHM%(t#, hh%, mm%)
    PRINT "Sunset :"; t#; " or "; hh%; ":"; mm%; sT$
ELSE
    PRINT "Invalid Date!"
END IF

    PRINT "Press Any Key To Continue..."
    DO
    LOOP WHILE INKEY$ = ""
END SUB

SUB DemoCompInt
    PRINT : PRINT
    PRINT "Compound Interest & Time To Double"
    INPUT "Principle: "; p!
    INPUT "Annual Int Rate: "; i!
    INPUT "Num. Times Compounded: "; c!
    INPUT "Num. Periods to Calculate: "; n!

    y! = CompInt(p!, i!, c!, n!)
    PRINT "The answer is: "; y!
    X% = TimeToDouble%(i!, c!)
    PRINT "Num Periods it would take to double your money: "; X%
    PRINT "Press Any Key To Continue..."
    DO
    LOOP WHILE INKEY$ = ""
END SUB

SUB DemoDateToJulian
    PRINT : PRINT
    PRINT "DateToJulian"
    INPUT "Please Enter Month (mm): "; mn%
    INPUT "Please Enter Day (dd): "; dy%
    INPUT "Please Enter Year (yyyy): "; yr%
    X& = DateToJulian(mn%, dy%, yr%)
    PRINT "The Julian Date is: "; X&
    y# = JulianToSerial(X&)
    PRINT "The Serial Date is: "; y#
    X& = SerialToJulian(y#)
    PRINT "From Serial To Julian: "; X&
    PRINT "Press Any Key To Continue..."
    DO
    LOOP WHILE INKEY$ = ""
END SUB

SUB DemoDayOfWeek
    PRINT : PRINT
    PRINT "Day of Week"
    INPUT "Please Enter Month (mm): "; mn%
    INPUT "Please Enter Day (dd): "; dy%
    INPUT "Please Enter Year (yyyy): "; yr%
    X% = DayOfWeek(mn%, dy%, yr%)
    PRINT "The answer is :"; X%

    PRINT "Press Any Key To Continue..."
    DO
    LOOP WHILE INKEY$ = ""

END SUB

SUB DemoIsHoliday
    DIM sh1 AS STRING
    DIM sh2 AS STRING

    PRINT : PRINT
    PRINT "Is Today A Holiday?"
    INPUT "Please Enter Month (mm): "; mn%
    INPUT "Please Enter Day (dd): "; dy%
    INPUT "Please Enter Year (yyyy): "; yr%
    IF IsHoliday(sh1, sh2, mn%, dy%, yr%) THEN
        PRINT "Yes! : "; sh1; " & "; sh2
    ELSE
        PRINT "Sorry no..."
    END IF

    PRINT "Press Any Key To Continue..."
    DO
    LOOP WHILE INKEY$ = ""
END SUB

SUB DemoIsLeapYear
    PRINT : PRINT
    PRINT "IsLeapYear"
    INPUT "Please Enter Year (xxxx): "; X%
    y% = IsLeapYear(X%)
    PRINT "The answer is :"; y%

    PRINT "Press Any Key To Continue..."
    DO
    LOOP WHILE INKEY$ = ""

END SUB

SUB DemoJulianToDate
    PRINT : PRINT
    PRINT "JulianToDate"
    INPUT "Please Enter Julian Date: "; jd&
    X% = JulianToDate(jd&, mn%, dy%, yr%)
    PRINT "The answer is :"; mn%; "/"; dy%; "/"; yr%

    PRINT "Press Any Key To Continue..."
    DO
    LOOP WHILE INKEY$ = ""
END SUB

SUB DemoMiles
    PRINT : PRINT
    PRINT "Miles Conversion Demo"
    INPUT "Please Enter Miles: "; m!
    ft! = MilesToFeet(m!)
    mi! = FeetToMiles(ft!)
    PRINT "Feet : "; ft!
    PRINT "Back to miles : "; mi!

    in! = FeetToInches(ft!)
    ft! = InchesToFeet(in!)
    PRINT "In Inches : "; in!
    PRINT "And Back to feet : "; ft!

    mt! = InchesToMeters(in!)
    in! = MetersToInches(mt!)
    PRINT "From inches to meters : "; mt!
    PRINT "And back to inches : "; in!

    km! = MilesToKm(mi!)
    mi! = KmToMiles(km!)
    PRINT "From miles to kilometers : "; km!
    PRINT "And back to miles : "; mi!

    PRINT "Press Any Key To Continue..."
    DO
    LOOP WHILE INKEY$ = ""
END SUB

SUB DemoStrTok
'Test the Strtoken Function
CLS
PRINT "Test the Strtoken Function"
LINE INPUT "Enter string: ", p$
' Set up the characters that separate tokens.
Delimiters$ = " ,;:().?" + CHR$(9) + CHR$(34)
' Invoke StrTok$ with the string to tokenize.
Token$ = StrTok$(p$, Delimiters$)
WHILE Token$ <> ""
   PRINT Token$
   ' Call StrTok$ with a null string so it knows this
   ' isn't the first call.
   Token$ = StrTok$("", Delimiters$)
WEND
PRINT "Press Any Key To Continue..."
DO
LOOP WHILE INKEY$ = ""
END SUB

SUB MainMenu
    DO WHILE -1
        'Main Menu
        CLS
        PRINT "==========================================="
        PRINT "        GLOBAL FUNCTIONS TEST PROGRAM"
        PRINT "================MAIN MENU=================="
        PRINT "1] String Functions"
        PRINT "2] Conversion Functions"
        PRINT "3] Date/Time Functions"
        PRINT "Q] Quit"
        PRINT ""
        PRINT "Please Select"
        DO
            A$ = INKEY$
        LOOP WHILE A$ = ""
        A$ = UCASE$(A$)
        SELECT CASE A$
            CASE "1": CALL StringMenu
            CASE "2": CALL ConvertMenu
            CASE "3": CALL DateMenu
            CASE "Q": END
        END SELECT
        LOOP
END SUB

SUB StringMenu
    DO WHILE -1
        CLS
        PRINT "==========================================="
        PRINT "        GLOBAL FUNCTIONS TEST PROGRAM"
        PRINT "===========String Functions================"
        PRINT "1] String Token"
        PRINT "M] Return To Main"
        PRINT ""
        PRINT "Please Select"
        A$ = ""
        DO
            A$ = INKEY$
        LOOP WHILE A$ = ""
        A$ = UCASE$(A$)
        SELECT CASE A$
            CASE "1": CALL DemoStrTok
            CASE "M": EXIT SUB
            CASE ELSE: BEEP
        END SELECT
    LOOP
END SUB

