/********************************************************************
TEXTDEMO.C  --  Demo program for text version of the menu library

(c) copyright 1994 SoftCraft, Inc.
all rights reserved

06/14/94        released

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
You must register to use the library for  commercial use or any other program to be 
distributed.  Registration information is in the REGISTER.DOC file or call SoftCraft, Inc.
708-360-0073.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
********************************************************************/
#include <stdio.h>
#include <conio.h>
#include <graph.h>
#include <string.h>
#include "def.h"                            /* include file for required constants */
#include "txt-menu.h"                    /* structures and externals for text menu library */

char *demo_items[] = {                  /* array of titles for menu items */
      "Red",                                    /* capital letters are hot keys */
      "Blue",
      "Green",
      "bLack",
      "Yellow"};                  
      
char *kb_demo_menu = "rbgly";     /* hot keys for menu items -- these must be in lower case */ 

short menu_demo(void)
{
  struct MENU demo_menu;
  short action;
   
  demo_menu.st_row  = 5;                                                /* starting row */
  demo_menu.st_col = 5;                                                  /* starting column -- horizontal menu defaults to 1 */
  demo_menu.shadow = SHADOW;                                   /* sets shadow option, SHADOW -- NO_SHADOW */
  demo_menu.noel = 5;                                                     /* number of elements in options list */
  demo_menu.horv = HORZ;                                              /* sets orientation of menu, HORZ (horizontal) -- VERT (vertical) */
  demo_menu.border = BORDER;                                      /* sets border option, BORDER -- NO_BORDER */
  demo_menu.mouse_pre = MOUSE_PRE;                        /* indicates presence of mouse, NO_MOUSE -- MOUSE_PRE (mouse present) */
  demo_menu.mouse_button = MOUSE_BUTTON_LEFT;    /* indicates which mouse button is active, MOUSE_BUTTON_LEFT -- MOUSE_BUTTON_RIGHT */
  demo_menu.justify = CENTER;                                       /* sets justification for text in vertical menu, LEFT, RIGHT, CENTER */
  demo_menu.border_color = 15;                                       /* sets foreground color for border */
  demo_menu.bk_color = 3;                                              /* sets background color for main menu */
  demo_menu.fore_color = 1;                                            /* sets text color for current selection  */
  demo_menu.sel_bk_color = 0;                                        /* sets background color for current selection */
  demo_menu.sel_fore_color = 15;                                     /* sets text color for current selection  */
  demo_menu.title_fore = 12;                                             /* sets text color for title */
  demo_menu.title_bk = 7;                                                 /* sets background color for title */
  demo_menu.shadow_color = 14;                                      /* set the color for the shadow */
  demo_menu.mouse_sens_x = 100;                                  /* indicates mouse x axis sensitivity in mikeys */
  demo_menu.mouse_sens_y = 100;                                   /* indicates mouse y axis sensitivity in mikeys */
  demo_menu.title = "Demo";                                             /* string represents title for menu, if null will not display, should not be larger than .ele_width */
  demo_menu.kb_sel = kb_demo_menu;                            /* pointer to hot keys for menu selections */
  demo_menu.sel = demo_items;                                       /* pointer to menu selection titles */
  demo_menu.ele_width = 0;                                              /* initializes ele_width to 0 just for safety */
  action = get_menu_key(&demo_menu);                            /* display menu and get selection */
  /******************************************************
     add code here to execute your selection
     first title will be 0,
     last title will be noel - 1
  *******************************************************/   
  return(action);                                                                /* demo simply returns the selection */
}

void main (void)
{
  short action;
  
  _setvideomode( _TEXTC80);                                            /* sets video mode to 80 column color text */
  action = menu_demo();                                                   /* executes routine to setup menu and get choice */
  _settextposition(2,10);
  printf("action type = %d",action);                                      /* prints result on screen */
  getch();                                                                          /* pause program to get result */
  _setvideomode(_DEFAULTMODE);                                   /* return to videomode used before program started */
}    
  