DECLARE SUB TimeDelay (Q%)            '   | QBWORM.BAS  OCTOBER 1990 |
DECLARE SUB LoadClipArt ()            '   | by R.AUKERMAN,   ONEWORD |
DECLARE SUB PaintScene ()             '         revised October 1992
DECLARE SUB Animation (Q%)            '         revised November 1993
DECLARE SUB KeyTraps ()

'--- GRAPHIC PIECES WILL BE IDENTIFIED WITH THESE NAMES -----
COMMON SHARED Aworm(), Bworm(), B2worm(), Cworm(), Dworm()
COMMON SHARED Oword(), Speed(), Calw(), Rule(), Esk(), Black()

'-----------------|  QUICKBASIC 4 / PDS 7 VERSION  |--------------------
    'AN EXAMPLE OF BLOADing GRAPHIC IMAGES INTO ARRAYS AND THEN SIMPLY
    'PUTing THEM ON THE SCREEN IN AN INCREMENTED LOOP AS AN ANIMATION.
    'PAGE FLIPPING IS USED TO HIDE OBJECT RE-PAINTING AND THE ASSOCIATED
    '"RIPPLE".  THIS VERSION WAS WRITTEN IN MICROSOFT QUICKBASIC.  IT
    'WILL RUN IN THE QB Environment OR CAN BE COMPILES WITH QB 4.5.
    'ELEVEN BSAVED GRAPHICS ARE LOADED IN THE PROGRAM.    THESE .BAX
    'FILES MUST BE IN THE CURRENT DIRECTORY WITH QBWORM.BAS WHEN RUNNING.
    '------- Requires either VGA or EGA; uses BASIC Screen 9. ---------
    '-------------------------------------------------------------------
    'BLOADable IMAGES WERE PREPARED WITH THE BSAVEPCX PROGRAM by ONEWORD.
    '-------------------------------------------------------------------

 ' ---| INITIALIZE SCREEN and ANIMATION SPEED |--------------

     Q% = 12                  'Q value sets speed at outset; 1 is fastest
     CLS
     SCREEN 9, , 1, 1: CLS    'BASIC SCREEN 9, Page 1 visable and active

 '---|  BLOAD AND PUT A DIVERSION GRAPHIC ASAP  |------------
     
     DIM LOADING(1000)                 '*** NOTICE: The FIVE line here
      LL$ = "LOADING.BAX"                  'comprise the full and
          DEF SEG = VARSEG(LOADING(0))     'complete BLOAD process for
            BLOAD LL$, VARPTR(LOADING(0))  'any BSAVEd memory image
     PUT (250, 150), LOADING, PSET         'including color bit map
                                           'graphics.
 '---|  DIMENSION ARRAYS |----
     DIM Aworm(1450)
     DIM Bworm(1450)
     DIM B2worm(1450)                      'Each of these integer
     DIM Cworm(1450)                       'arrays is given a dimension
     DIM Dworm(1450)                       'which is one half the number
     DIM Black(1450)                       'of bytes in the file it is
     DIM Speed(1168)                       'expected to hold.
     DIM Calw(3430)
     DIM Rule(1650)
     DIM Esk(590)
     DIM Oword(590)

 '---|  TRAPS FOR SPEED AND ESC. KEYS |------------
   CALL KeyTraps
 '---|  BLOAD GRAPHICS INTO BASIC'S WORK SPACE |------
   CALL LoadClipArt
 '---|  PUT BACKGROUND ON TWO PAGES |---------
   CALL PaintScene
 '---|  PUT ANIMATION CLIPS ON HIDDEN PAGE AND "FLIP"|-------
   CALL Animation(Q%)

 END
 '------------------|  END of MAIN MODULE |-------------------
 ' The SUB KeyTraps use the routines below, part of the main module.
 '---|  Event trap subs ( KeyTraps) are below |---
Slowdown:
     Q% = Q% + 1                     'SLOWDOWN
     IF Q >= 64 THEN Q = 64
     RETURN
Speedup:
      Q% = Q% - 1                    'SPEEDUP
     IF Q% <= 1 THEN Q% = 1
     RETURN
CleanClose:                          'TIDY UP SCREEN
     SCREEN , , 1, 0: CLS            'and END
     SCREEN , , 0, 0: CLS
     END

SUB Animation (Q%)
    ' ----- START RECYCLE LOOP.   20 PASSES COULD BE ANY NUMBER. ---------
    ' ----- GOSUB FOR TIME DELAY INFO.
    ' -----   -------------------------------------
 G% = 1                  'Initialize page flip algorithm

FOR S = 1 TO 20 STEP 1
    ' ---- START ANIMATION LOOPS.  PUT 5 WORM CELS AND SOME BLACK COVER
    ' ---- PATCHES.   GOSUB FOR TimeDelay INFO.    PAGES FLIP 1-0-1-0
    ' ---- EXPLOITING SCREEN 9 Active/Visual OPTION IN A SWAP ALGORITHM.
    'Re set NumLock, CapLock, ScrollLock off to guarentee trapping.
    DEF SEG = 0                        ' Turn off Bits 4,5,and 6 at
    POKE &H417, PEEK(&H417) AND &H8F   ' offset 417.

   FOR X = 20 TO 476 STEP 24
1       PUT (X, 179), Aworm, PSET
           SCREEN , , 1 - G, G
            CALL TimeDelay(Q%)
           G = 1 - G                         ' The animation relies on
        PUT (X, 179), Bworm, PSET            ' putting a sequence of
           SCREEN , , 1 - G, G               ' worm cels on the screen so
            CALL TimeDelay(Q%)               ' that each will "cover" the
           G = 1 - G                         ' one that preceded it.  To
        PUT (X, 179), B2worm, PSET           ' further simplify, the cels
           SCREEN , , 1 - G, G               ' are all the same height.
            CALL TimeDelay(Q%)               ' While the X coordinate of
           G = 1 - G                         ' the PUT statement steps
2        PUT (X, 179), Cworm, PSET           ' 24 pixels in the FOR-NEXT
           SCREEN , , 1 - G, G               ' loop shown on the left,
            CALL TimeDelay(Q%)               ' the Y location (179) does
           G = 1 - G                         ' not change.  This practice
        PUT (X + 7, 179), B2worm, PSET       ' wastes memory but makes
           SCREEN , , 1 - G, G               ' the program easier to
            CALL TimeDelay(Q%)               ' understand and reproduce.
           G = 1 - G                         ' The program BSAVEPXC cuts
       PUT (X, 179), Black, PSET             ' and BSAVEs cels like these
       PUT (X + 24, 179), Dworm, PSET        ' with absolute precision.
          SCREEN , , 1 - G, G
           CALL TimeDelay(Q%)                ' PUT's are done non-visible.
          G = 1 - G                          ' Review the SCREEN 9 syntax
                                             ' in a BASIC ref. for more.
   NEXT X
    ' -- PAUSE AND CLEAN UP AT THE END OF THE WALK, THEN LOOP -----
3     PUT (500, 179), Aworm, PSET
          SCREEN , , 1 - G, G
           Q% = Q% * 2
          CALL TimeDelay(Q%)
           Q% = Q% / 2
          G = 1 - G
   FOR B = 1 TO 2
      PUT (500, 179), Black, PSET
          SCREEN , , 1 - G, G: G = 1 - G   ' FLIP; CLEAN THE OTHER PAGE --
   NEXT B

NEXT                         'If uninterupted, worm walks 20 times

ClearScreens:
     SCREEN , , 1, 0: CLS
     SCREEN , , 0, 0: CLS
END SUB

SUB KeyTraps
' This SUB revised 12-1-93 to reduce trap count. Keyboard shift
' Locks are turned off and kept off in the animation loop.

'------Define keys and actions. -------
' Page 180, PDS 6, BASIC Language Reference
' Syntax:
'   KEY n%, CHR$(keyboardflag) + CHR$(scancode)
'----------------------------------------------------------
'Numeric pad cursor:
     ON KEY(12) GOSUB Slowdown        '4,left on numeric pad
     ON KEY(13) GOSUB Speedup         '6,right on numeric pad
  KEY(12) ON: KEY(13) ON
'
'Cursor "T" on 101 kbd. Left/Right arrows
     KEY 15, CHR$(128) + CHR$(75)
     ON KEY(15) GOSUB Slowdown
  KEY(15) ON
     KEY 19, CHR$(128) + CHR$(77)
     ON KEY(19) GOSUB Speedup
  KEY(19) ON
'
' Escape
     KEY 23, CHR$(0) + CHR$(1)
     ON KEY(23) GOSUB CleanClose
  KEY(23) ON
END SUB

SUB LoadClipArt
      DEF SEG                               ' Load, in this SUB means
        VA$ = "AWORM.BAX"                   ' load a BSAVEd image file
         DEF SEG = VARSEG(Aworm(0))         ' image file from floppy
           BLOAD VA$, VARPTR(Aworm(0))      ' or hard disk storage to
        VB$ = "BWORM.BAX"                   ' RAM.  Each BSAVEd file
         DEF SEG = VARSEG(Bworm(0))         ' is written into an integer
           BLOAD VB$, VARPTR(Bworm(0))      ' array, dimensioned to
        VB2$ = "B2WORM.BAX"                 ' hold it and named to
         DEF SEG = VARSEG(B2worm(0))        ' identify it (Aworm, Bworm,
           BLOAD VB2$, VARPTR(B2worm(0))    ' B2worm, etc.)
        VC$ = "CWORM.BAX"
         DEF SEG = VARSEG(Cworm(0))         ' Most important BASIC keeps
           BLOAD VC$, VARPTR(Cworm(0))      ' the image arrays in its
        VD$ = "DWORM.BAX"                   ' own workspace and via
         DEF SEG = VARSEG(Dworm(0))         ' VARSEG and VARPTR, BASIC
           BLOAD VD$, VARPTR(Dworm(0))      ' takes over all the work
        VS$ = "SPEED.BAX"                   ' of finding empty memory
         DEF SEG = VARSEG(Speed(0))         ' to hold the images and
           BLOAD VS$, VARPTR(Speed(0))      ' keeping track of the
        VW$ = "CALWORM.BAX"                 ' exact addresses.  It is
         DEF SEG = VARSEG(Calw(0))          ' this assistance from
           BLOAD VW$, VARPTR(Calw(0))       ' BASIC that lets a novice
        VR$ = "RULE.BAX"                    ' tackle a program briming
         DEF SEG = VARSEG(Rule(0))          ' with imported bit map
           BLOAD VR$, VARPTR(Rule(0))       ' color images and move
        VE$ = "ESK.BAX"                     ' them around at will.
         DEF SEG = VARSEG(Esk(0))
           BLOAD VE$, VARPTR(Esk(0))       ' Loading a named image
        VO$ = "Oword.BAX"                   ' file take TWO "standard"
         DEF SEG = VARSEG(Oword(0))         ' statements; DEF SEG....
           BLOAD VO$, VARPTR(Oword(0))      ' and BLOAD.....
     GET (0, 0)-(106, 36), Black
     CLS          'Get a Black backgground cover patch
END SUB

SUB PaintScene
    ' ----- DRAW LINES AND PUT GRAPHICS ON ACTIVE (HIDDEN) PAGE --------
     SCREEN , , 0, 1            'Page 1 still visual but 0 is now active
     LINE (21, 216)-(603, 216), 7
     LINE (602, 218)-(602, 280), 6      ' This is somewhat cryptic.
     LINE (601, 261)-(601, 281), 6      ' With a few lines and
     LINE (600, 261)-(600, 281), 6      ' graphic pieces loaded in
     LINE (22, 218)-(602, 218), 14      ' SUB LoadClipArt the back-
     LINE (21, 219)-(21, 280), 6        ' ground scene is quickly drawn.
     LINE (22, 261)-(22, 281), 6        ' The animated worm is later
     LINE (23, 261)-(23, 281), 6        ' put to work in this scene.
     PUT (60, 120), Calw, PSET          ' With PCOPY a duplicate is
     PUT (360, 300), Speed, PSET        ' made on page 1 to accomodate
     FOR R = 24 TO 504 STEP 96          ' the page flipping in the
         PUT (R, 220), Rule, PSET       ' Animation SUB.
     NEXT R
     PUT (363, 323), Esk, PSET          ' All graphic pieces (Speed,
     PUT (60, 300), Oword, PSET         ' Esk, Rule, etc) are reusable.

     PCOPY 0, 1                'Copy all of Page 0 to Page1

  ' ----- MAKE PAGE 0 VISABLE, PAGE 1 IS ACTIVE (BUT OUT OF VIEW) ------
     SCREEN , , 1, 0
END SUB

SUB TimeDelay (Q%)
    FOR R = 1 TO Q% ^ 2       'TIME DELAY; SEE SLOWDOWN/SPEEDUP SUBS
    LINE (5, 10)-(635, 10), 0 'TRIM TIME WITH LINE LENGTH (workload)
    NEXT                      'INITIALIZE Q IN THE MAIN MODULE WITH A
END SUB                       'DEFAULT DELAY INTERVAL.

